	device zxspectrum128
        ORG #6000
begin
 include "TSPor.inc"

 ld bc,TSConfig
 xor a
 out (c),a
 
 ld bc,SysConfig,a,6
 out (c),a

 LD	BC,VConfig
 LD	A,VID_NOGFX
 OUT	(C),A

 ld hl,$4000,de,$4001,bc,6144,(hl),l:ldir
 call setpal

 ld a,$20
fill_vram:
 call clear_page_dma
 inc a
 cp $29
 jr nz,fill_vram
 
 ld  bc,VPage,a,$20:out (c),a

VID_16C         equ $01
VID_256C        equ $02
VID_360X288     equ $C0
PLANE0_MODE		equ VID_256C
RASTER_SIZE		equ VID_360X288
VID_NOGFX       equ $20

 LD	BC,VConfig
 LD	A,VID_360X288|VID_256C
 OUT	(C),A

TSU_T0ZEN		equ $04
TSU_T1ZEN		equ $08
TSU_T0EN		equ $20
TSU_T1EN		equ $40
TSU_SEN			equ $80

;-------draw lines
 ld a,$20
 ld bc,Page3
 out (c),a

 xor a;ld a,$FF
 ld hl,$E000
fillp:
 push af,hl
 ld de,hl,bc,511,(hl),a
 inc de
 ldir
 pop hl
 inc h,h
 jr nz,nonextp
 ld bc,Page3
 in a,(c)
 inc a
 out (c),a
 ld h,$C0
nonextp:
 pop af
 dec a:jr nz, fillp
;----------------------------------------------------
waits
 ei:halt
 call setpal

 ld hl,$4200
l_cf:ld a,0:inc a:ld (l_cf+1),a
 and 1:jr z,skipy
l_cc:ld a,0
 inc a
 cp $10
 jr nz,br1
 xor a
br1:
 ld (l_cc+1),a

skipy:
 ld a,(l_cc+1)
 ld (l_cb+1),a

 ld e,0
lp0:
 ld b,0

pass_2:
l_cb:ld a,0

 ld c,a

 add a,10

 ld (l_cd+1),a

putc:
 ld a,c
 exx
 ld c,a,b,0
 ld hl,colors
 add hl,bc
 ld a,(hl)

cv: or $E0
 exx

 push de,hl
 ld l,a,h,0
 add hl,hl
 ld de,plasm_pal_b
 add hl,de
 ld e,(hl):inc hl
 ld d,(hl)
 pop hl
 ld (hl),e:inc hl
 ld (hl),d;:inc hl
 dec hl,hl,hl
 pop de

 inc c
 ld a,c
l_cd: cp 0

 jr nz,putc

 inc b
 ld a,b
 cp 2
 jr nz,pass_2

 ld a,(l_cb+1):inc a:ld (l_cb+1),a

 inc e
 ld a,e
 cp $0D
 jr nz,lp0

;$DFFE OP-bits 0,1
 ld bc,$DFFE:in a,(c):and 1:jr nz,next
 ld a,(cv+1)
 sub $10
 ld (cv+1),a
 jp next2
next:
 ld bc,$DFFE:in a,(c):and 2:jr nz,next2
 ld a,(cv+1)
 add a,$10
 ld (cv+1),a
next2:
 ld hl,0,($4000),hl
 jp waits
setpal:
 ;open FMAddr access from 0x8000
 ld bc, FMAddr
 ld a, %00010000;0x18
 out (c), a
;load CRAM
 ld de,0
 ld hl,$4000
 ld bc,512
 ldir
;close FMAddr
 ld bc, FMAddr
 xor a
 out (c), a
 ret
;colors
colors:
 db $00,$02,$04,$06,$08,$0A,$0C,$0E
 db $0C,$0A,$08,$06,$04,$02,$00,$00
 db $02,$04,$06,$08,$0A,$0C,$0E,$0C
 db $0A,$08,$06,$04,$02,$00,$00,$02
 db $04,$06,$08,$0A,$0C,$0E

;----------------------------------------------------
clear_page_dma:
 push af
 ld bc,Page3
 out (c),a
 ld hl,0;+$0101
 ld (#c000),hl
 ld bc,#1AAF
 ld hl,$C000
 out (c),l;DMASAddrL    EQU	#1AAF
 inc b
 out (c),h;l;DMASAddrH    EQU	#1BAF
 inc b

 out (c),a;h;DMASAddrX    EQU	#1CAF
 inc b
;TSL:;2.  DMADAddrL   2,     8194 ,  2 ,  .  Fill  Src  Dest  
 ld l,2
 out (c),l;DMADAddrL    EQU	#1DAF
 inc b
 out (c),h;l;DMADAddrH    EQU	#1EAF
 inc b
 out (c),a;h;DMADAddrX    EQU	#1FAF
 ld l,255
 ld b,#26

;		defb #28,200	;
;		defb #26,#ff	;
;		defb #27,%00000100    ; DMA_FILL

 out (c),l;DMALen    EQU	#26AF
 inc b
 inc b
 ld a,31;15+2;(15+1)*2=32, 32*512=16384
 out (c),a;;l;DMANum    EQU	#28AF
 dec b
 ld a,%00000100; FILL->RAM
 out (c),a;DMACtrl   EQU	#27AF
waitdma1:
 inf
 jp m,waitdma1
 pop af
 ret
;----------------------------------------------------
plasm_pal_b:
; dw 1024*0+32*0+0;R.G.B-0
; include "mkpal\pal.inc"
 dw 1057;0
 dw 3171;1
 dw 5285;2
 dw 7399;3
 dw 9513;4
 dw 11627;5
 dw 13741;6
 dw 15855;7
 dw 17969;8
 dw 20083;9
 dw 22197;10
 dw 24311;11
 dw 26425;12
 dw 28539;13
 dw 30653;14
 dw 32767;15
 dw 1152;16
 dw 3264;17
 dw 5376;18
 dw 7488;19
 dw 9600;20
 dw 11680;21
 dw 13793;22
 dw 15907;23
 dw 18020;24
 dw 20134;25
 dw 22248;26
 dw 23338;27
 dw 25452;28
 dw 27566;29
 dw 29680;30
 dw 31730;31
 dw 4160;32
 dw 6272;33
 dw 8384;34
 dw 10496;35
 dw 12608;36
 dw 14720;37
 dw 16834;38
 dw 18948;39
 dw 21062;40
 dw 23176;41
 dw 25289;42
 dw 27371;43
 dw 28461;44
 dw 30575;45
 dw 32689;46
 dw 32755;47
 dw 7168;48
 dw 8256;49
 dw 10368;50
 dw 12480;51
 dw 14593;52
 dw 16706;53
 dw 18821;54
 dw 20935;55
 dw 23049;56
 dw 25163;57
 dw 27277;58
 dw 29391;59
 dw 31505;60
 dw 32594;61
 dw 32628;62
 dw 32694;63
 dw 8192;64
 dw 10240;65
 dw 12354;66
 dw 14468;67
 dw 16582;68
 dw 18696;69
 dw 20809;70
 dw 22923;71
 dw 24013;72
 dw 26127;73
 dw 28241;74
 dw 30355;75
 dw 32469;76
 dw 32535;77
 dw 32601;78
 dw 32667;79
 dw 8195;80
 dw 10245;81
 dw 12327;82
 dw 14441;83
 dw 16555;84
 dw 18669;85
 dw 20783;86
 dw 22897;87
 dw 25011;88
 dw 27125;89
 dw 29239;90
 dw 31353;91
 dw 32442;92
 dw 32508;93
 dw 32574;94
 dw 32639;95
 dw 7176;96
 dw 9226;97
 dw 11308;98
 dw 13422;99
 dw 15536;100
 dw 17650;101
 dw 19764;102
 dw 21878;103
 dw 23992;104
 dw 26074;105
 dw 27164;106
 dw 29278;107
 dw 31391;108
 dw 32479;109
 dw 32543;110
 dw 32607;111
 dw 5132;112
 dw 7182;113
 dw 9264;114
 dw 11378;115
 dw 13492;116
 dw 15606;117
 dw 17720;118
 dw 18810;119
 dw 20923;120
 dw 23037;121
 dw 25151;122
 dw 27263;123
 dw 29375;124
 dw 31487;125
 dw 32575;126
 dw 32639;127
 dw 2062;128
 dw 4112;129
 dw 6225;130
 dw 8339;131
 dw 10453;132
 dw 12567;133
 dw 14681;134
 dw 16795;135
 dw 17885;136
 dw 19999;137
 dw 22111;138
 dw 24223;139
 dw 26335;140
 dw 28447;141
 dw 30559;142
 dw 32671;143
 dw 13;144
 dw 1103;145
 dw 3217;146
 dw 5331;147
 dw 7445;148
 dw 9559;149
 dw 11673;150
 dw 13787;151
 dw 15901;152
 dw 18015;153
 dw 19103;154
 dw 21215;155
 dw 23295;156
 dw 25407;157
 dw 27519;158
 dw 29631;159
 dw 74;160
 dw 140;161
 dw 206;162
 dw 2320;163
 dw 4434;164
 dw 6548;165
 dw 8662;166
 dw 10776;167
 dw 12858;168
 dw 14972;169
 dw 17086;170
 dw 19199;171
 dw 21311;172
 dw 23423;173
 dw 25535;174
 dw 27647;175
 dw 134;176
 dw 200;177
 dw 266;178
 dw 1356;179
 dw 3469;180
 dw 4527;181
 dw 6641;182
 dw 8755;183
 dw 10869;184
 dw 12983;185
 dw 15097;186
 dw 17211;187
 dw 19325;188
 dw 21439;189
 dw 23551;190
 dw 25599;191
 dw 160;192
 dw 226;193
 dw 292;194
 dw 358;195
 dw 2472;196
 dw 4586;197
 dw 6700;198
 dw 8814;199
 dw 10928;200
 dw 13010;201
 dw 15124;202
 dw 17238;203
 dw 19352;204
 dw 21466;205
 dw 23548;206
 dw 25598;207
 dw 160;208
 dw 224;209
 dw 288;210
 dw 1377;211
 dw 3491;212
 dw 5605;213
 dw 7719;214
 dw 9833;215
 dw 11947;216
 dw 14061;217
 dw 16175;218
 dw 18289;219
 dw 20403;220
 dw 22517;221
 dw 23542;222
 dw 25592;223
 dw 160;224
 dw 224;225
 dw 1312;226
 dw 3424;227
 dw 5536;228
 dw 7649;229
 dw 9763;230
 dw 11877;231
 dw 13991;232
 dw 16105;233
 dw 18219;234
 dw 20333;235
 dw 22447;236
 dw 23537;237
 dw 25586;238
 dw 27636;239
 dw 128;240
 dw 2240;241
 dw 4352;242
 dw 6464;243
 dw 8576;244
 dw 10688;245
 dw 12801;246
 dw 14915;247
 dw 17029;248
 dw 18119;249
 dw 20233;250
 dw 22347;251
 dw 24461;252
 dw 26574;253
 dw 28656;254
 dw 30706;255

plasm_pal_e:

end
	display /d,end-begin
	savebin "plasm.bin",begin,end-begin

